# PV Performance Labs Tools for Python

Useful tools for photovoltaics and beyond!

<p align="left">
  <table>
    <tr>
      <td>PyPI version</td>
      <td>
        <a href="https://badge.fury.io/py/pvpltools">
          <img src="https://badge.fury.io/py/pvpltools.svg" alt="PyPI version" height="18"/>
        </a>
      </td>
    </tr>
    <tr>
      <td>License</td>
      <td>
        <a href="https://github.com/pvplabs/pvpltools/blob/main/LICENSE">
          <img src="https://img.shields.io/pypi/l/pvpltools.svg" alt="license" />
        </a>
      </td>
    </tr>
    <tr>
      <td>Build status</td>
      <td>
        <a href="http://pvpltools.readthedocs.org/en/latest/">
          <img src="https://readthedocs.org/projects/pvpltools/badge/?version=latest" alt="documentation build status" />
        </a>
        <a href="https://github.com/pvplabs/pvpltools/actions/workflows/pytest.yml?query=branch%3Amain">
          <img src="https://github.com/pvplabs/pvpltools/actions/workflows/pytest.yml/badge.svg?branch=main" alt="GitHub Actions Testing Status" />
        </a>
        <a href="https://codecov.io/gh/pvplabs/pvpltools">
          <img src="https://codecov.io/gh/pvplabs/pvpltools/branch/main/graph/badge.svg" alt="codecov coverage" />
        </a>
      </td>
  </table>
</p>

Latest news
-----------
2024-02-13: More proof that these tools are useful!  The module efficiency functions were put to good use in [this new study by Lelia Deville and her colleagues][101]:

[101]: https://doi.org/10.1002/pip.3763


Copyright
---------

Copyright (c) 2019-2025 Anton Driesse, PV Performance Labs.


License
-------

GPL-3.0, but feel free to let me know if that causes any problems!


Citing
------

When referring to this software in either academic or commercial context,
please use a citation similar to the following:

- A. Driesse,
"PV Performance Labs Tools for Python", (2020), GitHub repository,  https://github.com/pvplabs/pvpltools

When referring to specific functions, docs strings or algorithms,
please add specifics to the citation.

The following report introduces the new ADR PV module efficiency model
and compares it to the IEC 61853 efficiency matrix interpolation/extrapolation method as well as several other published models:

- Driesse, Anton, & Stein, Joshua.
  "From IEC 61853 power measurements to PV system simulations."
  SAND2020-3877, Sandia National Laboratories, Albuquerque, NM, 2020. [doi:10.2172/1615179.][102]

[102]: https://pvpmc.sandia.gov/download/7737/

Additional publications related to the contents of pvpltools
will be listed here as they become available.


Acknowledgements
----------------

The contents of this repository have been developed
before, during or after various projects; as a product or byproduct;
with funding in whole, in part, or not at all.

I would like to acknowledge Sandia National Labs and the US DOE for
substantial project funding as well encouragement to publish open source code.

I also acknowledge and thank all the contributors to pvlib-python,
parts of which I use very frequently in the context of my work.


Getting help
------------

The doc strings within the code are currently the primary source of documentation.

Feel free to contact me with questions or suggestions though.
For commercial use, extended support and related services are available.
